/* Elektronische Wächeklammer - electronic clothes peg (German Version)
 * by Mtronixx (Markus Klingler)
 * 
 * for ESP12 (not for ESP01!)
 * 
 * This is the Version Without the LED
 * 
 *  pinOne, pinTwo, A0 - Conections to the peg (see circuit diagramm)
 *  
 */

//conect pin one to resistor - adc - cloths - pin Two

#include <ESP8266WiFi.h>

//pin map

#define pinOne 2 //GPIO 2
#define pinTwo 4 //GPIO 4

//==================your home network

const char* ssid = "yourWIFIname"; //type your ssid
const char* password = "yourPassword"; //type your password


WiFiServer server(80);

void setup() {
  Serial.begin(115200);
  delay(10);


  pinMode(pinOne, OUTPUT);
  digitalWrite(pinOne, LOW);
  pinMode(pinTwo, OUTPUT);
  digitalWrite(pinTwo, LOW);
  

  // Connect to WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");

  // Start the server
  server.begin();
  Serial.println("Server started");

  // Print the IP address
  Serial.print("Use this URL to connect: ");
  Serial.print("http://");
  Serial.print(WiFi.localIP());
  Serial.println("/");

}

void loop() {

  // Check if a client has connected
  WiFiClient client = server.available();
  

  if (!client) {
    return;
  }

  // Wait until the client sends some data
  Serial.println("new client");
  while (!client.available()) {
    delay(1);
  }

  client.flush();

 //this is to prevent electrolytic decomposition
  digitalWrite(pinOne, HIGH);
  delay(3);
  digitalWrite(pinOne, LOW);
  digitalWrite(pinTwo, HIGH);
  delay(3);

 //measure and calculate the values
  int analoggValue = 1024 - analogRead(A0);
  float percentValue = 0;

  if (analoggValue < 512) {
    percentValue = 0;

  } else {
    percentValue = ((analoggValue - 512.00) * 100.00) / 500.00;
    if (percentValue >= 98 || analoggValue == 1023) {
      percentValue = 100;

    }
  }


  Serial.print("Trocknungsgrad: ");
  Serial.print(percentValue);
  Serial.print("% (ADC-Wert: ");
  Serial.print(analoggValue);
  Serial.println(")");
  digitalWrite(pinTwo, LOW);

  // Return the response
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println(""); //  do not forget this one
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  client.println("<head><title>Elektronische Waecheklammer</title>");
  client.println("<meta http-equiv=\"refresh\" content=\"30; URL=/\" /></head>");

  client.println("<font size=\"30\"><b><u> Elektronische Waecheklammer</u></b></font><font size=\"20\">");
  client.println("<br><br>");

  client.print("<progress value=\"");
  client.print(percentValue);
  client.println("\" max=\"100\"></progress>");
  client.print("<br>Aktueller Trocknungsgrad: ");
  client.print(percentValue);
  client.println("%");

  client.println("</font></html>");

  delay(1);
  Serial.println("Client disonnected");
  Serial.println("");

}
